
/* Exemple d'utilisation du driver MIDI pour SpeedoGDOS */

#include <stdio.h>
#include <string.h>
#include <ext.h>
#include <tos.h>
#include <aes.h>
#include <vdi.h>
#include "bindings.h"

int open_work(int);
int ap_id;

int main(int argc,char *argv[])
{
	int handle,i;
	int res,ver;
	char name[28];
	
	if (vq_vgdos () != GDOS_FSM)
	{
		printf("Ce programme a besoin de SpeedoGDOS\n");
		printf("This program need SpeedoGDOS\n");
		getchar();
		return(0);
	}
	ap_id=appl_init();	/* Donne moi un identificateur d'application */
	
	if (argc>1)					/* Est ce qu'on a reu un nom en parametre? */
	{ 
		for ( i=111; i<121; i++)	/* Recherche le driver MIDI entre */
		{													/* L'Id 111 et 120 */
			handle=open_work(i); /* Alors ouvre la station de travail */
			if(handle)						/* C'est le driver MIDI? */
				break;
		}
		
		if (handle)						/* L'ouverture c'est bien pass? */
		{
			vq_driver_info(handle,&res,&ver,&res,&res,name);	/* Affiche le nom du driver */
			printf("\n%s version %04x\n",name,ver);

			if(vmid_load(handle,argv[1],0L))	/* Chargement du fichier MIDI ok? */
			{
				printf("Ecouter et patientez!\n");
				printf("Please wait....!\n");
				vmid_play(handle);					/* Commence a jouer */
				vmid_unload(handle);				/* C'est fini on libere la memoire */
			}

			v_clrwk(handle);					/* on rinitialise le driver */
			v_clswk(handle);				/* et on le ferme */
		}
		else
		{
			printf("Impossible d'ouvrir la station de travail MIDI!\n");
			printf("Open MIDI workstation is not possible!\n");
			getchar();
		}
	}
	else
	{
		printf("\nVeuillez faire glisser un fichier son sur ce programme");
		printf("\nAppuyez sur une touche...");
		printf("\nPlease drag a sound file on this program");
		printf("\nHit any key...");
		getchar();
	} 
	appl_exit();
	return 0;
}

int open_work(int dev)
{
/****************************************************************
	Routine d'ouverture de la Station de travail sur un priphrique
****************************************************************/
	
/****************************************************************
	 ATTENTION! Respectez l'ordre exact de ce qui suit 
*****************************************************************/

	int h;
	register int i;
	for (i=0;i<10;_VDIParBlk.intin[i++]=1);	
	_VDIParBlk.intin[0]=dev;
	_VDIParBlk.intin[10]=2;
	v_opnwk(_VDIParBlk.intin,&h,_VDIParBlk.intout);

	if(h)				/* Est ce que l'ouverture de la station de travail est ok? */
	{
		if(	*(long *)_VDIParBlk.intout=='MIDI') /* Est ce le driver MIDI? */
		{
			printf(" Maximum Note   : %d\n",_VDIParBlk.intout[3]); /* Affiche les infos */
			printf(" Maximum Track 	: %d\n",_VDIParBlk.intout[4]);
			return h;
		}
		else
		{
			v_clswk(h);				/* et on le ferme */
			printf("%d : Ce n'est pas un driver MIDI\n",dev);
			printf("%d : It is not a MIDI driver\n",dev);
			return 0;
		}
	}
	return h;
}
